/////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __ROM_H__
#define __ROM_H__

/////////////////////////////////////////////////////////////////////////////////////////////////
// variables
/////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct ws_romHeaderStruct
{
  BYTE developperId;
  BYTE supportSystem;
  BYTE cartId;
  BYTE unknown;
  BYTE romSize;
  BYTE eepromSize;
  BYTE additionnalCapabilities;
  BYTE realtimeClock;
  WORD checksum;
} ws_romHeaderStruct;

extern ws_romHeaderStruct ws_romHeader;

/////////////////////////////////////////////////////////////////////////////////////////////////
// functions
/////////////////////////////////////////////////////////////////////////////////////////////////
BYTE*       ws_rom_load(const void* p_data, size_t datasize);
DWORD       ws_rom_romSize(void);
DWORD       ws_rom_eepromSize(void);
DWORD       ws_rom_sramSize(void);
const char* ws_rom_developper(void);

#endif
